LeetCode:357. Count Numbers with Unique Digits

LeetCode:357. Count Numbers with Unique Digits


Given a non-negative integer n, count all numbers with unique digits, x, where 0 ≤ x < 10n.

Example:
Given n = 2, return 91. (The answer should be the total numbers in the range of 0 ≤ x < 100, excluding [11,22,33,44,55,66,77,88,99])

Hint:

A direct way is to use the backtracking approach.
Backtracking should contains three states which are (the current number, number of steps to get that number and a bitmask which represent which number is marked as visited so far in the current number). Start with state (0,0,0) and count all valid number till we reach number of steps equals to 10n.
This problem can also be solved using a dynamic programming approach and some knowledge of combinatorics.
Let f(k) = count of numbers with unique digits with length equals k.
f(1) = 10, …, f(k) = 9 * 9 * 8 * … (9 - k + 2) [The first factor is 9 because a number cannot start with 0].


Hint写的很详细,找规律应该蛮好写。
注释掉的用找规律写的,后来看别人代码写了个回溯。其中用掩码来标识哪个数字用过,蛮有意思的。

Reference:回溯写法
http://www.cnblogs.com/grandyang/p/5582633.html


class Solution {
public:
    int DFS(int pre, int max, int used) {
        int res=0;
       if(pre<max)  ++res;
       else return res;
       for(int i=0;i<10;++i)
       {
           if(!(used&(1<<i)))//判断是否使用过
           {
               used|=(1<<i);
               int cur=10*pre+i;//竟然不能用pre=10*pre+i
               res+=DFS(cur,max,used);
               used&=~(1<<i);
           }
       }
       return res;
    }
    //i=0表示0用过,=1,表示1用过。
    int countNumbersWithUniqueDigits(int n) {
        if(!n)  return 1;
        int res = 1, max = pow(10, n), used = 0;
        for(int i=1;i<10;++i)
        {
            used|=(1<<i);
            res+=DFS(i,max,used);
            used&=~(1<<i);
        }
        return res;


        //if(n==1)    return 10;
        // int t=9;
        // for(int i=2;i<=n;++i)
        // {
        //     t*=(9-i+2);
        // }
        // return t+countNumbersWithUniqueDigits(n-1);
    }
};
给定一个整数数组 nums 和一个目标值 target,要求在数组中找出两个数的和等于目标值,并返回这两个数的索引。 思路1:暴力法 最简单的思路是使用两层循环遍历数组的所有组合,判断两个数的和是否等于目标值。如果等于目标值,则返回这两个数的索引。 此方法的时间复杂度为O(n^2),空间复杂度为O(1)。 思路2:哈希表 为了优化时间复杂度,可以使用哈希表来存储数组中的元素和对应的索引。遍历数组,对于每个元素nums[i],我们可以通过计算target - nums[i]的值,查找哈希表中是否存在这个差值。 如果存在,则说明找到了两个数的和等于目标值,返回它们的索引。如果不存在,将当前元素nums[i]和它的索引存入哈希表中。 此方法的时间复杂度为O(n),空间复杂度为O(n)。 思路3:双指针 如果数组已经排序,可以使用双指针的方法来求解。假设数组从小到大排序,定义左指针left指向数组的第一个元素,右指针right指向数组的最后一个元素。 如果当前两个指针指向的数的和等于目标值,则返回它们的索引。如果和小于目标值,则将左指针右移一位,使得和增大;如果和大于目标值,则将右指针左移一位,使得和减小。 继续移动指针,直到找到两个数的和等于目标值或者左指针超过了右指针。 此方法的时间复杂度为O(nlogn),空间复杂度为O(1)。 以上三种方法都可以解决问题,选择合适的方法取决于具体的应用场景和要求。如果数组规模较小并且不需要考虑额外的空间使用,则暴力法是最简单的方法。如果数组较大或者需要优化时间复杂度,则哈希表或双指针方法更合适。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值